(*

    Temporary File Stream Class
    Version 02.000
    (C) 1996, Glen Why


*)
unit TempFile;

interface
uses
  Windows, Classes;


(*
     TTempFileStream is TFileStream descendant that
     implements temporary file stream. Temporary stream
     allows read/write access. When user destroys
     TTempFileSTream instance, temporary file is automatically
     deleted. TTempFileStream creates files with the random name
     and 'gwt' prefix. Files are created in Windows'.
*)



type

     TTempFileStream = class( TFileStream )
     private
       FTmpFileName :String;
     public
       constructor Create;
       destructor Destroy; override;
     end;


implementation
uses
 consts;


{ TTempFileStream }

constructor TTempFileStream.Create;
var N, P :String;
begin
  SetLength( P, MAX_PATH );
  SetLength( P, GetTempPath( MAX_PATH, PChar( P ) ) );
  SetLength( N, MAX_PATH );
  if ( GetTempFileName( PChar( P ), 'gwtf', 0, PChar( N ) ) = 0 )
    then raise EFOpenError.CreateResFmt( SFOpenError, [ N ] );
  SetLength( N, lstrlen( PChar( N ) ) );
  inherited Create( N, fmCreate );
  FTmpFileName := N;
end;

destructor TTempFileStream.Destroy;
begin
  inherited destroy;
  DeleteFile( FTmpFileName );
end;


end.
